#include ".\clientthread.h"

CClientThread::CClientThread(void)
{
	delayFrame = 4;
	bWSAInit = false;
	bConnect = false;

	return;
}

CClientThread::~CClientThread()
{
	if(bWSAInit) WSACleanup();
}

bool CClientThread::initSocket(void)
{
	if(bWSAInit) return true;

	// Winsock gpJn
	if(WSAStartup(MAKEWORD(2,0), &wsaData) != 0) {
		printf("WSAStartup failed\n");
		return false;
	}

	// \Pbg̍쐬
	sock = socket(AF_INET, SOCK_STREAM, 0);
	if(sock == INVALID_SOCKET) {
		printf("error : socket(%d)\n", WSAGetLastError());
		return false;
	}

	bWSAInit = true;
	return true;
}

// ڑs(0=, 1=s, 2=zXgs\, 3=ɏnQ)
int CClientThread::connectServer(char *argDest, unsigned int argPort)
{
	if(!bWSAInit) return 3;

	deststr = argDest;					// AhX̎󂯎
	server.sin_port = htons(argPort);	// |[g̎w
	server.sin_family = AF_INET;

	server.sin_addr.S_un.S_addr = inet_addr(deststr);
	if(server.sin_addr.S_un.S_addr == 0xffffffff) {
		struct hostent *host;

		host = gethostbyname(deststr);
		if(host == NULL) {
			if(WSAGetLastError() == WSAHOST_NOT_FOUND) {
				printf("host not found : %s\n", deststr);
			}
			return 2;
		}

		addrptr = (unsigned int **)host->h_addr_list;

		while(*addrptr != NULL) {
			server.sin_addr.S_un.S_addr = *(*addrptr);

			// connect()loop𔲂܂
			if (connect(sock, (struct sockaddr *)&server, sizeof(server)) == 0) {
				break;
			}

			addrptr++;
			// connects玟̃AhXŎ܂
		}

		// connectSĎsꍇ
		if(*addrptr == NULL) {
			printf("error : connect(%d)\n", WSAGetLastError());
			return 1;
		}
	} else {
		// inet_addr()Ƃ

		// connectsG[\ďI
		if(connect(sock, (struct sockaddr *)&server, sizeof(server)) != 0) {
			printf("error : connect(%d)\n", WSAGetLastError());
			return 1;
		}
	}

	// ςςρ[
	bConnect = true;
	return 0;
}

// stringstringQbg(0=, 1=̃~X, 2=󂯎̃~X)
// XbhJnɎgƔߎSȂƂɂȂ邩炾߂
int CClientThread::communicate(string argStr, string *dstStr)
{
	int sendSize = send(sock, argStr.c_str(), argStr.length(), 0);

	if(sendSize < 0) {
		printf("error : send(%d)\n", WSAGetLastError());
		return 1;
	}

	memset(tempBuf, 0, sizeof(tempBuf));

	int recvSize = recv(sock, tempBuf, sizeof(tempBuf), 0);

	if(recvSize < 0) {
		printf("error : recv(%d)\n", WSAGetLastError());
		return 2;
	}

	*dstStr = tempBuf;
	return 0;
}

void CClientThread::disconnectServer(void)
{
	int sendSize = send(sock, "BYE!___\0", 8, 0);

	if(sendSize < 0) {
		printf("cli_error : send(%d)\n", WSAGetLastError());
		return;
	}

	shutdown(sock, 1);
	closesocket(sock);
	bConnect = false;

	return;
}

void CClientThread::setDelayFrame(unsigned int argFrm)
{
	delayFrame = argFrm;

	return;
}

int CClientThread::getDelayFrame(void)
{
	return (int)delayFrame;
}

bool CClientThread::getStateMessage(vector<PK_KeyState> *argArray)
{
	if(recvQueue.empty()) return false;
	*argArray = recvQueue.front();

	Lock();
	recvQueue.pop();
	Unlock();

	return true;
}

bool CClientThread::isBufferFilled(void)
{
	return bool(recvQueue.size() > delayFrame);
}

void CClientThread::Main(void)
{
    int		recvSize, objNum;
	char	recvBuf[PACKET_BUFSIZE];

	vector<PK_KeyState>	tmpPacket;

	if(!bConnect) return;

	memset(recvBuf, 0, sizeof(recvBuf));

	while(true) {
		// Iwo烋[v甲
		if(isEndWait) break;
		Sleep(1);

		// f[^M҂
		recvSize = recv(sock, recvBuf, 8, 0);

		// CLOSEH
		if(recvSize < 1) {
			printf("disconnect.\n");
			closesocket(sock);	// CLOSE
			bConnect = false;
			break;
		// Ȃ
		} else if(strcmp("BYE!___\0", recvBuf) == 0) {
			printf("shutdown.\n");
			shutdown(sock, 1);
		} else if(strcmp("PK_S2C_\0", recvBuf) == 0){
			recv(sock, recvBuf, 1, 0);
			objNum = (int)recvBuf[0];
			tmpPacket.resize(objNum);
			for(int i = 0; i < objNum; i++) {
				recv(sock, recvBuf, sizeof(PK_KeyState), 0);
				tmpPacket[i] = *((PK_KeyState *)recvBuf);
				// printf("PK_KeyState(%d): (%f, %f), %d\n", i, tmpPacket[i].dir[0], tmpPacket[i].dir[1], tmpPacket[i].sw[0]);
			}
			Lock();
			recvQueue.push(tmpPacket);	// 󂯎R}hvbV
			Unlock();
			cout << "Buffered size:" << recvQueue.size() << endl;
		}
    }

    return;
}

void CClientThread::sendKeyState(PK_KeyState *argPacket)
{
	send(sock, "PK_C2S_\0", 8, 0);
	send(sock, (char*)argPacket, sizeof(PK_KeyState), 0);

	return;
}
