#pragma once
#include <winsock2.h>
#include <stdio.h>
#include <queue>
#include <string>
#include "../KLFace2Thread.h"
#include "../PacketStruct.h"

const int PACKET_BUFSIZE = 256;


class CClientThread : public KLFace2Thread
{
private:
	//// Winsock's setup ////
	WSADATA			wsaData;
	sockaddr_in		server;
	char			tempBuf[PACKET_BUFSIZE];
	char			*deststr;
	unsigned int	**addrptr;
	SOCKET			sock;

	bool			bWSAInit, bConnect;
	unsigned int	delayFrame;

	queue<vector<PK_KeyState> >	recvQueue;

	// ʃXbh֐
	void	Main(void);

public:

	CClientThread(void);
	~CClientThread();

	bool	initSocket(void);
	int		connectServer(char *, unsigned int);
	void	disconnectServer(void);
	int		communicate(string, string *);

	void	setDelayFrame(unsigned int);
	int		getDelayFrame(void);

	bool	isBufferFilled(void);
	bool	getStateMessage(vector<PK_KeyState> *);

	void	sendKeyState(PK_KeyState *);

	void	sendForce(const char *argStr)
	{
		send(sock, argStr, 8, 0);
	};
};
