#include "./ClientThread.h"
#include <FK/FK.h>

int main(int argc, char *argv[])
{
	//// FK app's setup ////

	Fl_Window		mainWindow(512, 512, "Client");
	fk_Model		camera, lightModel, blockModel, sphereModel[2];
	fk_Light		light;
	fk_Block		block(1000.0, 10.0, 1000.0);
	fk_Sphere		sphere(4, 50.0);
	fk_Scene		scene;
	fk_Window		window(0, 0, 512, 512);

	CClientThread	client;
	string			tmpBuf;

	PK_KeyState			sendState;
	vector<PK_KeyState>	stateArray;

	fk_Vector	verticalVec[2];

	int		iJumpState[2];
	iJumpState[0] = 0; iJumpState[1] = 0;

	bool	sw[2];
	sw[0] = false; sw[1] = false;


	mainWindow.end();
	fk_InitMaterial();

	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(-1.0, -1.0, -1.0);

	// ̂̐ݒ
	blockModel.setShape(&block);
	blockModel.setMaterial(Brown);

	// ̂̐ݒ
	sphereModel[0].setShape(&sphere);
	sphereModel[0].setMaterial(Red);
	sphereModel[0].glMoveTo(500.0, 10.0, 500.0);
	sphereModel[0].setSmoothMode(true);
	sphereModel[1].setShape(&sphere);
	sphereModel[1].setMaterial(Green);
	sphereModel[1].glMoveTo(-500.0, 10.0, -500.0);
	sphereModel[1].setSmoothMode(true);

	// effBXvCXgɓo^
	scene.entryCamera(&camera);
	scene.entryModel(&blockModel);
	scene.entryModel(&lightModel);
	scene.entryModel(&sphereModel[0]);
	scene.entryModel(&sphereModel[1]);

	// EBhEփfBXvCXgo^
	window.setScene(&scene);
	window.setOGLPointerMode(false);

	// _̈ʒuƎpݒ
	camera.glMoveTo(0.0, 1000.0, 2000.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 1.0, 0.0);

	camera.setParent(&sphereModel[0]);

	mainWindow.show();
	window.show();

	// ڑ
	client.initSocket();
	if(client.connectServer((char*)fl_input("Input the server address", "localhost"), 22222)) {
		fl_alert("connect error.");
	}
	client.setDelayFrame(2);

	if(client.communicate("READY?_\0", &tmpBuf) == 0) {
		if(tmpBuf == "YEAH!__") {
			cout << "connected!" << endl;
			client.Start();
		} else {
			cout << "communicate failed(1)." << endl;
		}
	} else {
		cout << "communicate failed(2)." << endl;
	}

	//// FK main loop ////
	while(true) {

		static DWORD prevTime = timeGetTime();

		if(mainWindow.visible() == 0) {
			if(Fl::wait() == 0) {
				break;
			} else {
				continue;
			}
		}

		if(window.drawWindow() == 0) break;
		if(Fl::check() == 0) break;
		if(window.winOpenStatus() == false) continue;

		/*
		GetExitCodeThread(client.GetThreadID(), &dwThreadState);
		if(dwThreadState != STILL_ACTIVE) break;
		*/
		if(client.IsEnd()) break;

		// L[̍Đ
		do {
			if(!client.getStateMessage(&stateArray)) break;

			for(uint id = 0; id < stateArray.size(); id++) {
				static fk_Vector distVec;
				if(id == 0) {
					distVec = sphereModel[0].getPosition()-sphereModel[1].getPosition();
				} else {
					distVec = sphereModel[1].getPosition()-sphereModel[0].getPosition();
				}
				// ړ
				sphereModel[id].glTranslate(stateArray[id].dir[0]*10.0, 0.0, stateArray[id].dir[1]*10.0);
				if(distVec.dist() < 100.0) {
					if(id == 0) {
						sphereModel[0].glTranslate(distVec/distVec.dist()*10.0);
						sphereModel[1].glTranslate(stateArray[id].dir[0]*10.0, 0.0, stateArray[id].dir[1]*10.0);
					} else {
						sphereModel[1].glTranslate(distVec/distVec.dist()*10.0);
						sphereModel[0].glTranslate(stateArray[id].dir[0]*10.0, 0.0, stateArray[id].dir[1]*10.0);
					}
				}

				// Wv
				switch(iJumpState[id]) {
				case 0:
					if(!sw[id] & stateArray[id].sw[0]) {
						verticalVec[id].init();
						verticalVec[id].y = 20.0;
						iJumpState[id] = 1;
					} else {
						break;
					}
				case 1:
					if(verticalVec[id].y < 5.0 && (!sw[id] & stateArray[id].sw[0])) {
						verticalVec[id].y = 20.0;
						iJumpState[id] = 2;
					}
				case 2:
					if(distVec.dist() < 100.0) {
						verticalVec[id] = distVec/distVec.dist()*10.0;
					}
					sphereModel[id].glTranslate(verticalVec[id]);
					verticalVec[id].y -= 0.98*0.98*0.98;
					if(sphereModel[id].getPosition().y <= 0.0) {
						iJumpState[id] = 0;
					}
					break;
				default:
					break;
				}

				fk_Vector tmpVec = sphereModel[id].getPosition();

				if(tmpVec.x > 500.0)	tmpVec.x = 500.0;
				if(tmpVec.x < -500.0)	tmpVec.x = -500.0;
				if(tmpVec.y < 0.0)		tmpVec.y = 0.0;
				if(tmpVec.z > 500.0)	tmpVec.z = 500.0;
				if(tmpVec.z < -500.0)	tmpVec.z = -500.0;

				sphereModel[id].glMoveTo(tmpVec);
				if(id == 0) camera.glMoveTo(0.0, -tmpVec.y+1000.0, 2000.0);

				sw[id] = stateArray[id].sw[0];
			}
		} while(client.isBufferFilled());

		// L[̊i[Ɠ]
		sendState.dir[0] = 0.0f;
		sendState.dir[1] = 0.0f;

		if(window.getSpecialKeyStatus(FK_UP, false)) {
			sendState.dir[1] -= 1.0f;
		}
		if(window.getSpecialKeyStatus(FK_DOWN, false)) {
			sendState.dir[1] += 1.0f;
		}
		if(window.getSpecialKeyStatus(FK_LEFT, false)) {
			sendState.dir[0] -= 1.0f;
		}
		if(window.getSpecialKeyStatus(FK_RIGHT, false)) {
			sendState.dir[0] += 1.0f;
		}
		sendState.sw[0] = window.getKeyStatus('X', false);

		client.sendKeyState(&sendState);

		while(timeGetTime() - prevTime < 15) Sleep(1);
		prevTime = timeGetTime();
	}

	client.End();
	client.disconnectServer();

	return 0;
}
