#include ".\serverparent.h"

CServerParent::CServerParent(void)
{
	bWSAInit = false;
	bListen = false;
	numConnected = 0;
}

CServerParent::~CServerParent(void)
{
	if(bWSAInit) WSACleanup();
}

bool CServerParent::initSocket(void)
{
	if(bWSAInit) return true;

	// Winsock gpJn
	if(WSAStartup(MAKEWORD(2,0), &wsaData) != 0) {
		return false;
	}

	// T[o\Pbg쐬
	sock0 = socket(AF_INET, SOCK_STREAM, 0);
	if(sock0 == INVALID_SOCKET) {
		printf("error : socket(%d)\n", WSAGetLastError());
		return false;
	}

	bWSAInit = true;
	return true;
}

// |[goChListenJn(0=, 1=listens, 2=binds, 3=socketnQ)
int CServerParent::startListening(unsigned int argPort)
{
	if(!bWSAInit) return 3;

	addr.sin_port = htons(argPort);
	addr.sin_family = AF_INET;
	addr.sin_addr.S_un.S_addr = INADDR_ANY;

	// G[`FbNƃoCh
	setsockopt(sock0, SOL_SOCKET, SO_REUSEADDR, (const char *)&yes, sizeof(yes));
	if(bind(sock0, (struct sockaddr *)&addr, sizeof(addr)) != 0) {
		printf("error : bind(%d)\n", WSAGetLastError());
		return 2;
	}

	// listen Jn
	if(listen(sock0, PACKET_BUFSIZE) != 0) {
		printf("error : listen(%d)\n", WSAGetLastError());
		return 1;
	}

	// evC[XbhɃT[o\Pbg]
	player[0].setServerSocket(sock0);
	player[1].setServerSocket(sock0);
	player[2].setServerSocket(sock0);
	player[3].setServerSocket(sock0);

	return 0;
}

CPlayerThread * CServerParent::getPlayerThread(int argID)
{
	return &player[argID];
}

void CServerParent::shutdownServer(void)
{
	player[0].End();
	player[1].End();
	player[2].End();
	player[3].End();
	player[0].setServerSocket(INVALID_SOCKET);
	player[1].setServerSocket(INVALID_SOCKET);
	player[2].setServerSocket(INVALID_SOCKET);
	player[3].setServerSocket(INVALID_SOCKET);

	shutdown(sock0, 1);
	closesocket(sock0);

	return;
}
